* program that gets instruments for both broad and wage income;
* at the same time;
* computes the two definitions of taxable income;
* taxct = constant def close to 1990 definition in real terms;
* taxlm = locally moving definition of taxable income; 
* pce variable produced by fortran programs; 


OPTIONS errors=100;
libname bobo '/scratch/saez';


DATA bobo.tall;
SET bobo.tall;
ARRAY tallar (391) agex--E90_110;
  DO i = 1 TO 391;
    IF tallar(i)=. THEN tallar(i)=0;
  END;
RUN;
PROC SORT data=bobo.tall;
by FLPDYR ID;
RUN; 




*;
*;
*      d3tall;
*; 
*;
*;
DATA bobo.gruber;
INFILE '/scratch/saez/wag3.tab';
INPUT FLPDYR ID TAXF0 TAXS0 WRATEF0 WRATES0 TAXF1 TAXS1 
 WRATEF1 WRATES1 PCE TAXLM0 TAXLM1 TAXLN0 TAXLN1;
FLPDYR=FLPDYR-1900;
RUN;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
RUN;

DATA bobo.tall2;
MERGE bobo.gruber bobo.tall;
by FLPDYR ID;
RUN;

DATA bobo.gruber;
INFILE '/scratch/saez/bro3.tab';
INPUT FLPDYR ID TAXF0B TAXS0B RATEF0 RATES0 TAXF1B TAXS1B 
 RATEF1 RATES1 PCEB TAXLM0B TAXLM1B TAXLN0B TAXLN1B;
FLPDYR=FLPDYR-1900;
RUN;
PROC SORT data=bobo.gruber;
by FLPDYR ID;
RUN;

DATA bobo.tall2;
MERGE bobo.gruber bobo.tall2;
by FLPDYR ID;
RUN;

DATA bobo.tall2;
SET bobo.tall2;
DROP pceb taxf0b taxs0b taxf1b taxs1b taxlm0b taxlm1b taxln0b taxln1b;

refpce=0.929; * this is the pce for year 90;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN
ttladj=moving+empexp+iraded+keogh+penlty+almpd+secern;
IF flpdyr=87 THEN
ttladj=empexp+iraded+irasec+keogh+penlty+almpd;
IF flpdyr>=88 THEN
ttladj=empexp+iraded+irasec+keogh+penlty+almpd+health;
IF flpdyr=90 THEN
ttladj=hsetax+empexp+iraded+irasec+keogh+penlty+almpd+health;

IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi;
IF flpdyr=81 THEN 
broad=agi+ttladj+divrec+inty-divint+1.5*(cgdist+cgagi)+ui-uiagi;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi-ssagi;
IF flpdyr>=87 THEN 
broad=agi+ttladj-ssagi;

IF flpdyr<=80 OR flpdyr=82 OR flpdyr=83 THEN 
broadn=agi+ttladj+divrec-divagi+ui-uiagi-cgagi-cgdist;
IF flpdyr=81 THEN 
broadn=agi+ttladj+divrec+inty-divint+ui-uiagi-cgagi-cgdist;
IF flpdyr=84 OR flpdyr=85 OR flpdyr=86 THEN 
broadn=agi+ttladj+divrec-divagi-ssagi+ui-uiagi-cgagi-cgdist;
IF flpdyr>=87 THEN 
broadn=agi+ttladj-ssagi-cgagi-cgdist;

IF flpdyr<100 THEN item=0;
IF flpdyr<87 & itded ne 0  THEN item=1;
IF flpdyr=87 & agex>0 &
 (totitm ne 3750 & totitm ne 4500 & totitm ne 5600 & totitm ne 6200
& totitm ne 6800 & totitm ne 7400 & totitm ne 5150 & totitm ne 5900) THEN item=1;
IF flpdyr=88 & agex=0 &
 (totitm ne 3000 & totitm ne 5000 & totitm ne 2500 & totitm ne 4400)  THEN item=1;
IF flpdyr=88 & agex>0 &
 (totitm ne 3750 & totitm ne 4500 & totitm ne 5600 & totitm ne 6200
& totitm ne 6800 & totitm ne 7400 & totitm ne 5150 & totitm ne 5900)  THEN item=1;
IF flpdyr=89 & agex=0 &
 (totitm ne 3100 & totitm ne 5200 & totitm ne 2600 & totitm ne 4550)  THEN item=1;
IF flpdyr=89 & agex>0 &
 (totitm ne 3850 & totitm ne 4600 & totitm ne 5800 & totitm ne 6400
& totitm ne 7000 & totitm ne 7600 & totitm ne 5300 & totitm ne 6050)  THEN item=1;
IF flpdyr=90 & agex=0 &
 (totitm ne 3250 & totitm ne 5450 & totitm ne 2725 & totitm ne 4750)  THEN item=1;
IF flpdyr=90 & agex>0 &
 (totitm ne 4050 & totitm ne 4850 & totitm ne 6100 & totitm ne 6750
& totitm ne 7400 & totitm ne 8050 & totitm ne 5550 & totitm ne 6350)  THEN item=1;

IF flpdyr<=84 & (mars=1 | mars=4) THEN stdded=2300;
IF flpdyr<=84 & (mars=2 | mars=5) THEN stdded=3400;
IF flpdyr<=84 & (mars=3 | mars=6) THEN stdded=1700;
IF flpdyr=85 & (mars=1 | mars=4) THEN stdded=2390;
IF flpdyr=85 & (mars=2 | mars=5) THEN stdded=3540;
IF flpdyr=85 & (mars=3 | mars=6) THEN stdded=1770;
IF flpdyr=86 & (mars=1 | mars=4) THEN stdded=2480;
IF flpdyr=86 & (mars=2 | mars=5) THEN stdded=3670;
IF flpdyr=86 & (mars=3 | mars=6) THEN stdded=1835;
IF flpdyr=87 & (mars=1 | mars=4) THEN stdded=2540;
IF flpdyr=87 & (mars=2 | mars=5) THEN stdded=3760;
IF flpdyr=87 & (mars=3 | mars=6) THEN stdded=1880;
IF flpdyr=88 & (mars=1) THEN stdded=3000;
IF flpdyr=88 & (mars=4) THEN stdded=4400;
IF flpdyr=88 & (mars=2 | mars=5) THEN stdded=5000;
IF flpdyr=88 & (mars=3 | mars=6) THEN stdded=2500;
IF flpdyr=89 & (mars=1) THEN stdded=5100;
IF flpdyr=89 & (mars=4) THEN stdded=6550;
IF flpdyr=89 & (mars=2) THEN stdded=9200;
IF flpdyr=89 & (mars=5) THEN stdded=7200;
IF flpdyr=89 & (mars=3 | mars=6) THEN stdded=2000;
IF flpdyr=90 & (mars=1) THEN stdded=5300;
IF flpdyr=90 & (mars=4) THEN stdded=6800;
IF flpdyr=90 & (mars=2) THEN stdded=9550;
IF flpdyr=90 & (mars=5) THEN stdded=7500;
IF flpdyr=90 & (mars=3 | mars=6) THEN stdded=2050;

* standard deduction in 1990;
IF (mars=1) THEN refded=5300;
IF (mars=4) THEN refded=6800;
IF (mars=2) THEN refded=9550;
IF (mars=5) THEN refded=7500;
IF (mars=3 | mars=6) THEN refded=2050;

* age and blindness exemptions;
IF flpdyr<=86  & (mars=2 | mars= 3 | mars=5 | mars=6) THEN refded=refded+650*(xtot-xother);
IF flpdyr<=86  & (mars=1 | mars=4) THEN refded=refded+800*(xtot-xother);
IF flpdyr>=87 & (mars=2 | mars=3 | mars=5 | mars=6) THEN refded=refded+650*max(agexb,agex);
IF flpdyr>=87  & (mars=1 | mars=4) THEN refded=refded+800*max(agexb,agex);


IF flpdyr<=80  THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce
-xother*2050-refded)/refpce;
IF flpdyr<=80 & item=1 & (totitm+nonit+moving)*refpce/pce>refded THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totald*refpce/pce)/refpce;
IF flpdyr=81  THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce
-xother*2050-refded)/refpce;
IF flpdyr=81 & item=1 & (totitm+nonit+moving)*refpce/pce>refded THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totald*refpce/pce)/refpce;
IF flpdyr>=82 & flpdyr<=86 THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce
-xother*2050-refded)/refpce;
IF flpdyr>=82 & flpdyr<=86 & item=1 & (totitm+nonit+moving)*refpce/pce>refded THEN 
taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totald*refpce/pce)/refpce;
IF flpdyr>=87 & flpdyr<=89  THEN 
taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-refded)/refpce;
IF flpdyr>=87 & flpdyr<=89 & item=1 & totald*refpce/pce>refded THEN 
taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-totald*refpce/pce)/refpce;
IF flpdyr=90 THEN taxct=(agi-cgagi-cgdist-ssagi+hsetax+iraded+keogh+irasec-xtot*2050-totald)/refpce;
RUN;

DATA bobo.tall2;
set bobo.tall2
 (keep =
taxf0 taxs0 taxf1 taxs1
ratef0 ratef1 rates0 rates1
wratef0 wratef1 wrates0 wrates1
taxlm0 taxlm1 taxln0 taxln1

item stdded refded broadn refpce taxct broad pce
flpdyr id mars state  xtot xother
agi wages  cgagi cgdist ttladj
itded nonit exempt totitm agex agexb 

party partl sbtly sbtlss esty estlss rentyl ryltyl
frent passl npassl smbloss sbnpls
partny smbpy smbnpy passy npassy);
RUN;



DATA bobo.subset4;
set bobo.tall2;
if ID/50-ROUND(ID/50)=0;
run;

/* this program creates tall79 to tall90 and dtall82 to dtall90 */

DATA bobo.tall79 bobo.tall80 bobo.tall81 bobo.tall82 bobo.tall83 bobo.tall84 bobo.tall85 bobo.tall86 bobo.tall87 bobo.tall88 bobo.tall89 bobo.tall90 ;
SET bobo.tall2;
IF FLPDYR=79 THEN output bobo.tall79;
IF FLPDYR=80 THEN output bobo.tall80;
IF FLPDYR=81 THEN output bobo.tall81;
IF FLPDYR=82 THEN output bobo.tall82;
IF FLPDYR=83 THEN output bobo.tall83;
IF FLPDYR=84 THEN output bobo.tall84;
IF FLPDYR=85 THEN output bobo.tall85;
IF FLPDYR=86 THEN output bobo.tall86;
IF FLPDYR=87 THEN output bobo.tall87;
IF FLPDYR=88 THEN output bobo.tall88;
IF FLPDYR=89 THEN output bobo.tall89;
IF FLPDYR=90 THEN output bobo.tall90;
RUN; 

DATA bobo.dtall80;
SET bobo.tall80  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall81;
SET bobo.tall81  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall82;
SET bobo.tall82  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall83;
SET bobo.tall83  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall84;
SET bobo.tall84  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall85;
SET bobo.tall85  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall86;
SET bobo.tall86  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall87;
SET bobo.tall87  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall88;
SET bobo.tall88  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall89;
SET bobo.tall89  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;

DATA bobo.dtall90;
SET bobo.tall90  (RENAME = ( 
taxf0=taxf02 taxs0=taxs02
taxf1=taxf12 taxs1=taxs12
 ratef0=ratef02 ratef1=ratef12
rates0=rates02 rates1=rates12
 wratef0=wratef02 wratef1=wratef12
wrates0=wrates02 wrates1=wrates12
 taxlm0=taxlm02 taxlm1=taxlm12
 taxln0=taxln02 taxln1=taxln12

item=item2 stdded=stdded2 refded=refded2
 broadn=broadn2 refpce=refpce2 taxct=taxct2 broad=broad2 pce=pce2
flpdyr=flpdyr2 id=id  mars=mars2 state=state2  xtot=xtot2 xother=xother2
agi=agi2 wages=wages2  cgagi=cgagi2 cgdist=cgdist2 ttladj=ttladj2
itded=itded2 nonit=nonit2 exempt=exempt2
 totitm=totitm2 agex=agex2 agexb=agexb2 

party=party2 partl=partl2 sbtly=sbtly2
 sbtlss=sbtlss2 esty=esty2 estlss=estlss2
 rentyl=rentyl2 ryltyl=ryltyl2
frent=frent2 passl=passl2 npassl=npassl2
 smbloss=smbloss2 sbnpls=sbnpls2
partny=partny2
smbpy=smbpy2 smbnpy=smbnpy2 passy=passy2 npassy=npassy2));
RUN;


DATA bobo.d3tall82;
MERGE bobo.tall79 (IN=in1) bobo.dtall82 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall83;
MERGE bobo.tall80 (IN=in1) bobo.dtall83 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall84;
MERGE bobo.tall81 (IN=in1) bobo.dtall84 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall85;
MERGE bobo.tall82 (IN=in1) bobo.dtall85 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall86;
MERGE bobo.tall83 (IN=in1) bobo.dtall86 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall87;
MERGE bobo.tall84 (IN=in1) bobo.dtall87 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall88;
MERGE bobo.tall85 (IN=in1) bobo.dtall88 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall89;
MERGE bobo.tall86 (IN=in1) bobo.dtall89 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN;
DATA bobo.d3tall90;
MERGE bobo.tall87 (IN=in1) bobo.dtall90 (IN=in2);
BY ID;IF in1=1;IF in2=1;
RUN; 


DATA bobo.d3tall;
SET bobo.d3tall82 bobo.d3tall83 bobo.d3tall84
 bobo.d3tall85 bobo.d3tall86 bobo.d3tall87 bobo.d3tall88 bobo.d3tall89
 bobo.d3tall90;
IF mars=1 THEN mrs1=1;
ELSE mrs1=0;
IF mars=2 THEN mrs2=1;
ELSE mrs2=0;
IF mars>2 THEN mrs3=1;
ELSE mrs3=0;




broadr=broad/pce;
broad2r=broad2/pce2;
lnbroad=LOG(broadr);
dlogb=LOG(broad2r/broadr);


incefp=
LOG((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce));
fincefp=
LOG((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce));


inceff=
LOG((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce));
finceff=
LOG((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce));

incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr;
inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr;



dmargp=LOG((100-ratef1-rates1)/(100-ratef0-rates0));
dmargt=LOG((100-ratef02-rates02)/(100-ratef0-rates0)); 
fdmargp=LOG((100-ratef1)/(100-ratef0));
fdmargt=LOG((100-ratef02)/(100-ratef0)); 

wdmargp=LOG((100-wratef1-wrates1)/(100-wratef0-wrates0));
wdmargt=LOG((100-wratef02-wrates02)/(100-wratef0-wrates0)); 
wfdmargp=LOG((100-wratef1)/(100-wratef0));
wfdmargt=LOG((100-wratef02)/(100-wratef0)); 
RUN;


DATA bobo.d3subset;
set bobo.d3tall;
if ID/50-ROUND(ID/50)=0;
run;


